
*==================================================================

      SUBROUTINE SSF_EXTRAP_AND_IMAG(TRACE, CTRACE, RVX, XV,
     +   XX_TEMP, VV, RIMAG, DAT, DATW, DATW1, DATW2,
     +   NX, LT, DX, DT, NZ, DZ, Nw1, Nw2, Nw3,
     +   Nw4, Nw, Dw, DIP_max, RV_ratio)

      PARAMETER(PAI2=2*3.14159265359, V_cut_apparent=500)

      INTEGER   Nw1, Nw2, Nw3, Nw4, Nw
      INTEGER   NX, LT, NZ
      REAL      DX, DT, DZ, Dw, DIP_max, RV_ratio
     
c     DIMENSION TRACE(LT), DAT(LT, NX), TEST_V(300, 1290)
      DIMENSION TRACE(LT), DAT(LT, NX), XV(NX)
      DIMENSION VV(NZ, NX), RIMAG(NZ, NX), RV(10), RVX(3, NX)
 
      COMPLEX   DATW(NX, NW), DATW1(NX, NW), DATW2(NX, NW)
      COMPLEX   CTRACE(LT), XX_TEMP(NX)

*=====================================================================

      Dkx=PAI2/(NX*DX)
      RKz_max=COS(PAI2*DIP_max/360.0)

      V_cut_apparent2=V_cut_apparent*V_cut_apparent
      fcoe=Nw3*Dw/V_cut_apparent2
      
!      write(*,*) 'Nw1, Nw2, Nw3, Nw4, Nw', Nw1, Nw2, Nw3, Nw4, Nw
!      write(*,*) 'NX, LT, NZ='
!      write(*,*)  NX, LT, NZ 
!      write(*,*) 'DX, DT, DZ, Dw, DIP_max, RV_ratio='
!      write(*,*)  DX, DT, DZ, Dw, DIP_max, RV_ratio

c     open(35, file='velo', access='direct', recl=NZ)
c     open(36, file='data', access='direct', recl=LT)

c     do ix=1, NX
c      write(35, rec=ix) (vv(iz, ix), iz=1, nz)
c      write(36, rec=ix) (dat(it, ix), it=1, lt)
c     end do
      
c     close(36)
c     close(35)
c     pause 99

c     open(29, file='imageout', access='direct', recl=NZ)
c     open(37, file='reference_velo', access='direct', recl=NZ)
*====================================================================

      DO IX=1, NX
       DO IT=1, LT
        CTRACE(IT)=CMPLX(DAT(IT, IX),0.0)
       END DO
       CALL FFT1D(CTRACE, LT, +1)
       CALl HAMMING_WINDOW(CTRACE, NW1, NW2, NW3, Nw4, LT)
       DO IW=Nw1, NW4
        DATW(IX, IW-NW1+1)=CTRACE(IW)
       END DO
      END DO

*======= the main part of Split_Step fourier migration
 
      DO 3333 IZ=1, NZ

       WRITE(*,*)'IZ', IZ

*==============================================================

       DO IX=1,NX
        VV(IZ, IX)=VV(IZ, IX)*0.50
       END DO

       goto 909

       V_sum=0.0
       DO IX=1, NX
        V_sum=V_sum+VV(IZ, IX)
       END DO
       Vref=V_sum/NX

       CALL SSF_EXTRAPOLATION(DATw, VV, Vref, XX_TEMP,
     +      NX, Dkx, NZ, DZ, IZ, Nw1, Nw4, NW,
     +      Dw, RKz_max, fcoe)

909    continue

c       goto 808

*===== CHOOSING THE MULTIPLE REFERENCE VELOVITY 

      CALL AUTO_ADJUST_REFERENCE_V_CHOICE_2D(RVX, VV, RV, NX,
     +                NZ, IZ, RV_ratio, NUM_RV)

!      write(*,*) 'NUM_RV=', NUM_RV

      DO IX=1, NX
       DO IW=1, NW
        DATW2(IX, IW)=0.0
       END DO
      END DO

*====== EXTRPOLATING THE WAVE FIELD WITH THE MULTIPLE REFERENCE VELOVITY

      DO 66 IV=1, NUM_RV          
       
       Vref=RV(Iv)          
        
!       write(*,*) 'Iv=', Iv, 'Vref=', Vref

       DO IW=1, NW
        DO IX=1, NX
         DATw1(IX, IW)=DATw(IX, IW)
        END DO
       END DO

       CALL SSF_EXTRAPOLATION(DATw1, VV, Vref, XX_TEMP,
     +      NX, Dkx, NZ, DZ, IZ, Nw1, Nw4, NW,
     +      Dw, RKz_max, fcoe)

*====== THE INTERPOLATED WAVE FIELD ARE INTERPOLATED
 
        DO IX=1, NX
         Kx=RVX(2, IX)
         Vref_choose=RVX(3, IX)
c        TEST_V(Iz, Kx)=Vref_choose
         XV(Kx)=Vref_choose

         IF(Vref_choose.EQ.Vref) THEN
c         write(*,*) 'Kx=', Kx, 'Vref_choose=', Vref_choose
          DO Iw=1, NW
           DATw2(Ix, Iw)=DATw1(IX, IW)
          END DO
         END IF
        END DO
      
66     CONTINUE   

*====== EXTRACTING THE IMAGING VALUE

       DO IW=1, NW
        DO IX=1, NX
         DATw(IX, IW)=DATw2(IX, IW)
        END DO
       END DO
       
808   continue
     
      CALL WAVEFIELD_IMAGING(DATW, RIMAG, NX, NZ, NW, IZ)

*===== for outputing the reference velocity field

      DO IX=1, NX
       VV(IZ, IX)=XV(IX)
      END DO

3333  CONTINUE

c     do ix=1, NX
c      write(37, rec=ix) (test_v(iz, ix), iz=1, NZ)
c      write(29, rec=ix) (rimag(iz, ix), iz=1, nz)
c     end do


c     close(37)
c     close(29)

      RETURN
      END


*===========================================================================
 
      SUBROUTINE SSF_EXTRAPOLATION(DATw, VV, Vref, XX_TEMP,
     +  NX, Dkx, NZ, DZ, IZ, Nw1, Nw4, NW, 
     +  Dw, RKz_max, fcoe)

      PARAMETER(Wflag=-1.0)

      INTEGER   NX, NZ, Iz
      INTEGER   Nw1, Nw4, NW
      REAL      Dw, Dkx, DZ, RKz_max, Vref

      REAL      RPHASE
      DIMENSION VV(NZ, NX)
 
      COMPLEX   DATW(NX, NW), XX_TEMP(NX)
      COMPLEX   CPHASE

*---------------------------------------------------------------

      DO 344 IW=Nw1, Nw4

       IWW=Iw-Nw1+1
       W=IW*Dw
       IF(W.EQ.0.0) W=1.0E-8

       Rk=Vref/w
       Rkk=W*Dz/Vref
  
*========= PHASE SHIFT IN FREQUENCY-WAVENUMBER DOMAIN

       DO IX=1, NX
        XX_TEMP(IX)=DATw(IX, IWW)
       END DO
 
      CALL FFT1D(XX_TEMP, NX, 1)

*===============================================================

c      CALL BUTTERWORTH_FILTER(XX_TEMP, NX, DKx, W, fcoe)

*--------------------------------------------------------------

       DO 445 IKX=1, NX/2+1

        RKx=(IKx-1)*DKx
        SINSITAX=Rk*RKx
        SINSITAX=SINSITAX*SINSITAX

       IF(SINSITAX.GT.1.0) THEN
        RKz=SQRT(SINSITAX-1.0)
        RKzDz1=Wflag*RKz*Rkk
        RPHASE=EXP(RKzDz1)
        XX_TEMP(IKX)=XX_TEMP(IKX)*RPHASE
        IF(IKX.GT.1.and.IKX.NE.NX+2-IKX)
     +     XX_TEMP(NX+2-IKX)=XX_TEMP(NX+2-IKX)*RPHASE
       ELSE IF(SINSITAX.LE.1.0) THEN
        RKz=SQRT(1.0-SINSITAX)
        RKzDz1=Wflag*RKz*Rkk

        IF(RKz.GT.RKz_max) THEN
         CPHASE=CEXP(CMPLX(0.0, RKzDz1))
         XX_TEMP(IKX)=XX_TEMP(IKX)*CPHASE
         IF(IKX.GT.1.and.IKX.NE.NX+2-IKX)
     +     XX_TEMP(NX+2-IKX)=XX_TEMP(NX+2-IKX)*CPHASE
        ELSE
         RPHASE=EXP(Rkzdz1)
         XX_TEMP(IKX)=XX_TEMP(IKX)*RPHASE
         IF(IKX.GT.1.and.IKX.NE.NX+2-IKX)
     +     XX_TEMP(NX+2-IKX)=XX_TEMP(NX+2-IKX)*RPHASE
        END IF

       END IF

445    CONTINUE

*======= TIME SHIFT IN FREQUENCY-SPACE

       CALL FFT1D(XX_TEMP, NX, -1)

       DO IX=1, NX
        T_Shift=Wflag*Rkk*(Vref/VV(IZ, IX)-1.0)
        CPHASE=CEXP(CMPLX(0.0, T_shift))
        DATw(IX, IWW)=XX_TEMP(IX)*CPHASE

       ENDDO

344   CONTINUE

      RETURN
      END

*===========================================================================

      SUBROUTINE AUTO_ADJUST_REFERENCE_V_CHOICE_2D(RVX, VV, RV, NX,
     +                NZ, IZ, RV_ratio, NUM_RV)
      
      PARAMETER(Beta=0.01, LW=7)

      REAL    RV_ratio
      INTEGER NX, NZ, IZ, NUM_RV
      DIMENSION VV(NZ, NX), RV(10), RVX(3, NX)
      DIMENSION Fwindow(Lw)

      DO IV=1, 10
       RV(Iv)=0.0
      END DO

c     IF(IZ.EQ.28) THEN
c      DO IX=1, NX, 3
c       write(*,*) 'vv(iz, ix)=',ix, vv(iz, ix)
c      END DO 
c      pause
c     END IF
c     write(*,*) 'RV_ratio=', RV_ratio

      DO IX=1, NX
       if(vv(iz, ix).le.0.0) then
        write(*,*) 'ix=', ix, 'iz=', iz
        write(*,*) 'vv(iz, ix)=', vv(iz, ix)
       end if
       RVX(1, IX)=VV(IZ, IX)
       RVX(2, IX)=IX
       RVX(3, IX)=0.0
      END DO
 
*===== Midian Filtering for eliminate the wild velocity value
      LW2=LW*0.5
      DO IX=Lw2+1, NX-Lw2
       Jx=1
       DO JJx=IX-Lw2, IX+Lw2
        Fwindow(Jx)=RVX(1, JJx)
        Jx=Jx+1
       END DO
       CALL SORT_HERB(1, Lw, Fwindow)
       RVX(1, Ix)=Fwindow(LW2+1)
      END DO
      DO IX=1, Lw2
       RVX(1, Ix)=RVX(1, Lw2+1)
      END DO
      DO IX=NX-Lw2+1, NX
       RVX(1, Ix)=RVX(1, NX-Lw2)
      END DO
   
*===== Choosing the reference velocity
             
      CALL SORT_HERB(3, NX, RVX)

      Vmin=RVX(1, 1)
      Vmax=RVX(1, NX)   
      RV_limit=Vmax/Vmin      
      
c     write(*,*) 'Vmax, Vmin, RV_limit=', Vmax, Vmin, RV_limit

      IF(RV_limit.GT.6.0) THEN
       write(*,*) 'Vmax, Vmin=', Vmax, Vmin
       WRITE(*,*) 'THE LATERAL VELOCITY VARIATION OF '
       WRITE(*,*) 'THE DEFINED VELOCITY FIELD IS TOO'
       WRITE(*,*) 'SERVER! PLEASE CHECK IT'
      END IF

      RV_ratio_change=RV_ratio

1000  CONTINUE
 
      NUM_RV=1
      RV_sum=0.0
      NUM_sum=0

      NX_start=1
      DO 999 IX=1, NX-1

       RV_sum=RV_sum+RVX(1, IX)
       NUM_sum=NUM_sum+1
       RV_average=RV_sum/NUM_sum       
       V_ratio=RVX(1, IX+1)/RV_average

       IF(V_ratio.GT.RV_ratio) THEN

c       write(*,*)'NUM_sum=', NUM_sum
        RV(NUM_RV)=RV_average
        
        NX_final=IX
        DO JX=NX_start, NX_final
         RVX(3, JX)=RV_average
        END DO
        NX_start=NX_final+1

        NUM_RV=NUM_RV+1
        NUM_sum=0
        RV_sum=0.0

       END IF

       IF(NUM_RV.GT.10) THEN
        RV_ratio_change=RV_ratio*(1.0+Beta)
        GOTO 1000
       END IF  
  
999   CONTINUE

c     write(*,*)'NUM_sum=', NUM_sum
      RV(NUM_RV)=RV_average
      DO JX=NX_start, NX
       RVX(3, JX)=RV_average
      END DO

      DO JX=1, NX
       IF(RVX(3, JX).EQ.0.0) write(*,*) 'wrong'
      END DO

      RETURN
      END

*==============================================================

      SUBROUTINE WAVEFIELD_IMAGING(DATW, RIMAG, NX, NZ, NW, IZ)
                                                                                                                                                             
      DIMENSION RIMAG(NZ,NX)
      COMPLEX   DATW(NX, NW)
                                                                                                                                                             
      INTEGER   NX, NW, IZ
                                                                                                                                                             
      DO IX=1, NX
         ff=REAL(DATW(Ix, 1))+REAL(DATW(Ix, NW))
         DO IW=2, Nw-1
           ff=ff+2*REAL(DATW(Ix, IW))
         end do
         RIMAG(IZ, IX)=ff*0.5
      END DO
                                                                                                                                                             
      RETURN
                                                                                                                                                             
      END


*============================================================================

      SUBROUTINE sort_herb(nn, n, arr)

      INTEGER nn,n,M,NSTACK
      REAL arr(nn, n)
      PARAMETER (M=7,NSTACK=50)
      INTEGER i,ir,j,jstack,k,l,istack(NSTACK)
      REAL a(nn),temp(nn)

      jstack=0
      l=1
      ir=n
1     if(ir-l.lt.M)then
        do 12 j=l+1,ir
          do jn=1, nn
           a(jn)=arr(jn,j)
          end do
          do 11 i=j-1,l,-1
            if(arr(1,i).le.a(1))goto 2
            do jn=1, nn
             arr(jn, i+1)=arr(jn, i)
            end do
11        continue
          i=l-1
2         do jn=1, nn
           arr(jn, i+1)=a(jn)
          end do
12      continue
        if(jstack.eq.0)return
        ir=istack(jstack)
        l=istack(jstack-1)
        jstack=jstack-2
      else
        k=(l+ir)/2
        do jn=1, nn
         temp(jn)=arr(jn,k)
        end do
        do jn=1, nn
         arr(jn, k)=arr(jn, l+1)
        end do
        do jn=1, nn
         arr(jn, l+1)=temp(jn)
        end do
        if(arr(1, l).gt.arr(1, ir))then
         do jn=1, nn
          temp(jn)=arr(jn, l)
         end do
         do jn=1, nn
          arr(jn, l)=arr(jn, ir)
         end do
         do jn=1, nn
          arr(jn, ir)=temp(jn)
         end do
        endif
        if(arr(1, l+1).gt.arr(1, ir))then
         do jn=1, nn
          temp(jn)=arr(jn,l+1)
         end do
         do jn=1, nn
          arr(jn, l+1)=arr(jn, ir)
         end do
         do jn=1, nn
          arr(jn, ir)=temp(jn)
         end do
        endif
        if(arr(1, l).gt.arr(1, l+1))then
         do jn=1, nn
          temp(jn)=arr(jn, l)
         end do
         do jn=1, nn
          arr(jn, l)=arr(jn, l+1)
         end do
         do jn=1, nn
          arr(jn, l+1)=temp(jn)
         end do
        endif
        i=l+1
        j=ir
        do jn=1, nn
         a(jn)=arr(jn, l+1)
        end do 
3       continue
          i=i+1
        if(arr(1, i).lt.a(1))goto 3
4       continue
          j=j-1
        if(arr(1,j).gt.a(1))goto 4
        if(j.lt.i)goto 5
        do jn=1, nn
         temp(jn)=arr(jn,i)
        end do
        do jn=1, nn
         arr(jn,i)=arr(jn,j)
        end do
        do jn=1, nn
         arr(jn,j)=temp(jn)
        end do
        goto 3
5       do jn=1, nn
         arr(jn, l+1)=arr(jn, j)
        end do
        do jn=1, nn
         arr(jn, j)=a(jn)
        end do
        jstack=jstack+2
        if(jstack.gt.NSTACK)pause 'NSTACK too small in sort'
        if(ir-i+1.ge.j-l)then
          istack(jstack)=ir
          istack(jstack-1)=i
          ir=j-1
        else
          istack(jstack)=j-1
          istack(jstack-1)=l
          l=i
        endif
      endif
      goto 1

      END

*===========================================================================
        

      SUBROUTINE BUTTERWORTH_FILTER(X0_TEMP, NX, DKx, W, fcoe)
      
      INTEGER NX
      REAL    DKx, W, fcoe, fcoeW

      COMPLEX X0_TEMP(NX), CTEMP

      fcoeW=fcoe*W

      DO 445 IKX=1, NX/2+1
       RKx=(IKx-1)*DKx
       RKx2=RKx*RKx
       
*====== high dipping refelector pass
c        CTEMP=(RKx2, 0.0)/(RKx2, -fcoeW)

*====== low dipping refelector pass
       CTEMP=CMPLX(0.0, -fcoeW)/CMPLX(RKx2, -fcoeW)
        
       X0_TEMP(IKX)=X0_TEMP(IKX)*CTEMP
       IF(IKX.GT.1) X0_TEMP(NX+2-IKX)=X0_TEMP(NX+2-IKX)*CTEMP

445   CONTINUE

      RETURN
      END

*=============================================================================

      SUBROUTINE HAMMING_WINDOW(TT_TEMP, NW1, NW2, NW3, NW4, LT)

      PARAMETER(PAI=3.14159165359)
      INTEGER  Nw1, NW2, Nw3, Nw4
      COMPLEX  TT_TEMP(LT)

      DO IW=1, LT/2+1

         IF((NW1.NE.NW2).AND.(IW.GE.NW1.AND.IW.LE.NW2)) THEN
           Hammingw=0.54+0.46*cos(PAI*(Iw-Nw1)/(NW2-Nw1)-PAI)
           TT_TEMP(Iw)=TT_TEMP(Iw)*Hammingw
         ELSE IF((NW3.NE.NW4).and.(IW.GE.NW3.AND.IW.LE.NW4)) THEN
           Hammingw=0.54+0.46*cos(pai*(Nw3-Iw)/(Nw4-Nw3))
           TT_TEMP(Iw)=TT_TEMP(Iw)*Hammingw
         ELSE IF(IW.GT.Nw4.OR.IW.LT.Nw1) THEN
          TT_TEMP(IW)=0.0
         END IF

       END DO

       RETURN
       END

C--------------------------------------------------------------------------------

       SUBROUTINE  FFT1D(A,N,INV)

       implicit none

       integer  n,i,inv
       COMPLEX A(N)

       IF(INV.EQ.(-1)) THEN
         DO I=1,N
            a(i)=conjg(a(i))/float(n)
         ENDDO
         CALL FFTCC(a,N)
         do i=1,n
            a(i)=conjg(a(i))
         enddo
        else
           CALL FFTCC(a,N)
        ENDIF

        RETURN
        END

C *********************************************************
C
C   ROUTINE NAME :  FFTCC
C
C --------------------------------------------------------
C
C   PURPOSE :  COMPUTE THE FAST FOURIER TRANSFORM OF A
C              COMPLEX VALUED SEQUENCE
C
C   USAGE :  CALL FFTCC(A,N)
C
C   ARGUMENTS : A    COMPLEX VECTOR OF LENGTH N,
C                    ON INPUT A CONTAINS THE
C                    COMPLEX VALUED SEQUENCE TO BE
C                    TRANSFORMED.
C                    ON OUTPUT A IS REPLACED BY THE
C                    FOURIER TRANSFORM.
C               N    INPUT NUMBER OF DATA TO BY
C                    TRANSFORMED. N MAY BE ANY POSITIVE
C                    INTEGER.
C
C  NOTATION :   INFORMATION ON SPECIAL NOTATION AND
C               CONVENTIONS IS AVAILABLE IN THE MANUAL
C               INTRODUCTION OR THROUGH ROUTIME HELP
C
C  REMARKS : 1. FFTCC COMPUTES THE FOURIER TRANSFORM,X,
C              ACCORDING TO THE FOLLOWING FORMULA;
C
C              X(K+1)= SUM FORM J=0 TO N-1 OF
C                      A(J+1)*CEXP((0.0,(2.0*PI*J*K)/N))
C             FOR K=0,1,...,N-1 AND PI=3.1415926...
C
C             NOTE THAT X OVERWRITES A ON OUTPUT.
C
C           2. FFTCC CAN BE USED TO COMPUTE
C
C             X(K+1)= (1/N)*SUM FORM J = 0 TO N-1 OF
C                     A(J+1)*CEXP((0.0,(-2.0*PI*J*K)/N))
C             FOR K=0,1,...,N-1 AND PI=3.1415926...
C
C          BY PERFORMING THE FOLLOWING STEPS;
C
C             DO 10 I=1,N
C        10   A(I)= CONJG(A(I))
C             CALL FFTCC(A,N)
C             DO 20 I=1,N
C        20   A(I)= CONJG(A(I))/N
C
C ---------------------------------------------------------------
      SUBROUTINE FFTCC(A,N)
C     SPECIFICATIONS FOR ARGUMENTS
      INTEGER IWK(16384)
      REAL WK(16384)
      COMPLEX A(N)
C     SPECIFICATIONS FOR LOCAL VARIABLES
      REAL A0,A1,A2,A3,A4,B0,B1,B2,B3,B4,ZERO,ONE,TWO,
     +     Z0(2),Z1(2),Z2(2),Z3(2),Z4(2),HALF
      COMPLEX ZA0,ZA1,ZA2,ZA3,ZA4,AK2
      EQUIVALENCE (ZA0,Z0(1)),(ZA1,Z1(1)),(ZA2,Z2(1)),
     +            (ZA3,Z3(1)),(A0,Z0(1)),(B0,Z0(2)),
     +            (A1,Z1(1)),(B1,Z1(2)),(A2,Z2(1)),
     +            (B2,Z2(2)),(A3,Z3(1)),(B3,Z3(2)),
     +            (ZA4,Z4(1)),(Z4(1),A4),(Z4(2),B4)
      DATA ZERO/0.0/,HALF/0.5/,ONE/1.0/,TWO/2.0/
C    FIRST EXECUTABLE STATEMENT
C    RAD = MATH. CONS. 2*PI
      RAD=2*3.1415926
      C30=0.5*SQRT(3.0)
      IF(N.EQ.1) GO TO 9005
      K=N
      M=0
      J=2
      JJ=4
      JF=0
C    DETERMINE THE SQUARE FACTORS OF N
      IWK(1)=1
    5 I=K/JJ
      IF(I*JJ.NE.K) GO TO 10
      M=M+1
      IWK(M+1)=J
      K=I
      GO TO 5
   10 J=J+2
      IF(J.EQ.4) J=3
      JJ=J*J
      IF(JJ.LE.K) GO TO 5
      KT=M
C    DETERMINE THE REMAINING FACTORS OF N
      J=2
   15 I=K/J
      IF(I*J.NE.K) GO TO 20
      M=M+1
      IWK(M+1)=J
      K=I
      GO TO 15
   20 J=J+1
      IF(J.EQ.3) GO TO 15
      J=J+1
      IF(J.LE.K) GO TO 15
      K=IWK(M+1)
      IF(IWK(KT+1).GT.IWK(M+1)) K=IWK(KT+1)
      IF(KT.LE.0) GO TO 30
      KTP=KT+2
      DO 25 I=1,KT
      J=KTP-I
      M=M+1
      IWK(M+1)=IWK(J)
   25 CONTINUE
   30 MP=M+1
      IC=MP+1
      ID=IC+MP
      ILL=ID+MP
      IRD=ILL+MP+1
      ICC=IRD+MP
      ISS=ICC+MP
      ICK=ISS+MP
      ISK=ICK+K
      ICF=ISK+K
      ISF=ICF+K
      IAP=ISF+K
      KD2=(K-1)/2+1
      IBP=IAP+KD2
      IAM=IBP+KD2
      IBM=IAM+KD2
      MM1=M-1
      I=1
   35 L=MP-I
      J=IC-I
      IWK(ILL+L)=0
      IF((IWK(J-1)+IWK(J)).EQ.4) IWK(ILL+L)=1
      IF(IWK(ILL+L).EQ.0) GO TO 40
      I=I+1
      L=L-1
      IWK(ILL+L)=0
   40 I=I+1
      IF(I.LE.MM1) GO TO 35
      IWK(ILL+1)=0
      IWK(ILL+MP)=0
      IWK(IC)=1
      IWK(ID)=N
      DO 45 J = 1 ,M
      K=IWK(J+1)
      IWK(IC+J)=IWK(IC+J-1)*K
      IWK(ID+J)=IWK(ID+J-1)/K
      WK(IRD+J)=RAD/IWK(IC+J)
      C1=RAD/K
      IF(K.LE.2) GO TO 45
      WK(ICC+J)=COS(C1)
      WK(ISS+J)=SIN(C1)
   45 CONTINUE
      MM=M
      IF(IWK(ILL+M).EQ.1) MM=M-1
      IF(MM.LE.1) GO TO 50
      SM=IWK(IC+MM-2)*WK(IRD+M)
      CM=COS(SM)
      SM=SIN(SM)
   50 KB=0
      KN=N
      JJ=0
      I=1
      C1=1.0
      S1=0.0
      L1=1
   55 IF(IWK(ILL+I+1).EQ.1) GO TO 60
      KF=IWK(I+1)
      GO TO 65
   60 KF=4
      I=I+1
   65 ISP=IWK(ID+I)
      IF(L1.EQ.1) GO TO 70
      S1=JJ*WK(IRD+I)
      C1=COS(S1)
      S1=SIN(S1)
C    FACTORS OF 2, 3, AND 4 ARE
C    HANDLESEPARATELY.
   70 IF(KF.GT.4) GO TO 140
      GO TO (75,75,90,115), KF
   75 K0=KB+ISP
      K2=K0+ISP
      IF(L1.EQ.1) GO TO 85
   80 K0=K0-1
      IF(K0.LT.KB) GO TO 190
      K2=K2-1
      ZA4=A(K2+1)
      A0=A4*C1-B4*S1
      B0=A4*S1+B4*C1
      A(K2+1)=A(K0+1)-ZA0
      A(K0+1)=A(K0+1)+ZA0
      GO TO 80
   85 K0=K0-1
      IF(K0.LT.KB) GO TO 190
      K2=K2-1
      AK2=A(K2+1)
      A(K2+1)=A(K0+1)-AK2
      A(K0+1)=A(K0+1)+AK2
      GO TO 85
   90 IF(L1.EQ.1) GO TO 95
      C2=C1*C1-S1*S1
      S2=2.0*C1*S1
   95 JA=KB+ISP-1
      KA=JA+KB
      IKB=KB+1
      IJA=JA+1
      DO 110 II=IKB,IJA
      K0=KA-II+1
      K1=K0+ISP
      K2=K1+ISP
      ZA0=A(K0+1)
      IF(L1.EQ.1) GO TO 100
      ZA4=A(K1+1)
      A1=A4*C1-B4*S1
      B1=A4*S1+B4*C1
      ZA4=A(K2+1)
      A2=A4*C2-B4*S2
      B2=A4*S2+B4*C2
      GO TO 105
  100 ZA1=A(K1+1)
      ZA2=A(K2+1)
  105 A(K0+1)=CMPLX(A0+A1+A2,B0+B1+B2)
      A0=-HALF*(A1+A2)+A0
      A1=(A1-A2)*C30
      B0=-HALF*(B1+B2)+B0
      B1=(B1-B2)*C30
      A(K1+1)=CMPLX(A0-B1,B0+A1)
      A(K2+1)=CMPLX(A0+B1,B0-A1)
  110 CONTINUE
      GO TO 190
  115 IF(L1.EQ.1) GO TO 120
      C2=C1*C1-S1*S1
      S2=2.0*C1*S1
      C3=C1*C2-S1*S2
      S3=S1*C2+C1*S2
  120 JA=KB+ISP-1
      KA=JA+KB
      IKB=KB+1
      IJA=JA+1
      DO 135 II=IKB,IJA
      K0=KA-II+1
      K1=K0+ISP
      K2=K1+ISP
      K3=K2+ISP
      ZA0=A(K0+1)
      IF(L1.EQ.1) GO TO 125
      ZA4=A(K1+1)
      A1=A4*C1-B4*S1
      B1=A4*S1+B4*C1
      ZA4=A(K2+1)
      A2=A4*C2-B4*S2
      B2=A4*S2+B4*C2
      ZA4=A(K3+1)
      A3=A4*C3-B4*S3
      B3=A4*S3+B4*C3
      GO TO 130
  125 ZA1=A(K1+1)
      ZA2=A(K2+1)
      ZA3=A(K3+1)
  130 A(K0+1)=CMPLX(A0+A1+A2+A3,B0+B1+B2+B3)
      A(K1+1)=CMPLX(A0+A2-A1-A3,B0+B2-B1-B3)
      A(K2+1)=CMPLX(A0-A2-B1+B3,B0-B2+A1-A3)
      A(K3+1)=CMPLX(A0-A2+B1-B3,B0-B2-A1+A3)
  135 CONTINUE
      GO TO 190
  140 JK=KF-1
      KH=JK/2
      K3=IWK(ID+I-1)
      K0=KB+ISP
      IF(L1.EQ.1) GO TO 150
      K=JK-1
      WK(ICF+1)=C1
      WK(ISF+1)=S1
      DO 145 J=1,K
      WK(ICF+J+1)=WK(ICF+J)*C1-WK(ISF+J)*S1
      WK(ISF+J+1)=WK(ICF+J)*S1+WK(ISF+J)*C1
  145 CONTINUE
  150 IF(KF.EQ.JF) GO TO 160
      C2=WK(ICC+I)
      WK(ICK+1)=C2
      WK(ICK+JK)=C2
      S2=WK(ISS+I)
      WK(ISK+1)=S2
      WK(ISK+JK)=-S2
      DO 155 J=1,KH
      K=JK-J
      WK(ICK+K)=WK(ICK+J)*C2-WK(ISK+J)*S2
      WK(ICK+J+1)=WK(ICK+K)
      WK(ISK+J+1)=WK(ICK+J)*S2+WK(ISK+J)*C2
      WK(ISK+K)=-WK(ISK+J+1)
  155 CONTINUE
  160 K0=K0-1
      K1=K0
      K2=K0+K3
      ZA0=A(K0+1)
      A3=A0
      B3=B0
      DO 175 J=1,KH
      K1=K1+ISP
      K2=K2-ISP
      IF(L1.EQ.1) GO TO 165
      K=KF-J
      ZA4=A(K1+1)
      A1=A4*WK(ICF+J)-B4*WK(ISF+J)
      B1=A4*WK(ISF+J)+B4*WK(ICF+J)
      ZA4=A(K2+1)
      A2=A4*WK(ICF+K)-B4*WK(ISF+K)
      B2=A4*WK(ISF+K)+B4*WK(ICF+K)
      GO TO 170
  165 ZA1=A(K1+1)
      ZA2=A(K2+1)
  170 WK(IAP+J)=A1+A2
      WK(IAM+J)=A1-A2
      WK(IBP+J)=B1+B2
      WK(IBM+J)=B1-B2
      A3=A1+A2+A3
      B3=B1+B2+B3
  175 CONTINUE
      A(K0+1)=CMPLX(A3,B3)
      K1=K0
      K2=K0+K3
      DO 185 J=1,KH
      K1=K1+ISP
      K2=K2-ISP
      JK=J
      A1=A0
      B1=B0
      A2=0.0
      B2=0.0
      DO 180 K=1,KH
      A1=A1+WK(IAP+K)*WK(ICK+JK)
      A2=A2+WK(IAM+K)*WK(ISK+JK)
      B1=B1+WK(IBP+K)*WK(ICK+JK)
      B2=B2+WK(IBM+K)*WK(ISK+JK)
      JK=JK+J
      IF(JK.GE.KF) JK=JK-KF
  180 CONTINUE
      A(K1+1)=CMPLX(A1-B2,B1+A2)
      A(K2+1)=CMPLX(A1+B2,B1-A2)
  185 CONTINUE
      IF(K0.GT.KB) GO TO 160
      JF=KF
  190 IF(I.GE.MM) GO TO 195
      I=I+1
      GO TO 55
  195 I=MM
      L1=0
      KB=IWK(ID+I-1)+KB
      IF(KB.GE.KN) GO TO 215
  200 JJ=IWK(IC+I-2)+JJ
      IF(JJ.LT.IWK(IC+I-1)) GO TO 205
      I=I-1
      JJ=JJ-IWK(IC+I)
      GO TO 200
  205 IF(I.NE.MM) GO TO 210
      C2=C1
      C1=CM*C1-SM*S1
      S1=SM*C2+CM*S1
      GO TO 70
  210 IF(IWK(ILL+I).EQ.1)I=I+1
      GO TO 55
  215 I=1
      JA=KT-1
      KA=JA+1
      IF(JA.LT.1) GO TO 225
      DO 220 II=1,JA
      J=KA-II
      IWK(J+1)=IWK(J+1)-1
      I=IWK(J+1)+I
  220 CONTINUE
C   THE RESULT IS NOW PERMUTED TO NORMAL ORDER.
  225 IF(KT.LE.0) GO TO 270
      J=1
      I=0
      KB=0
  230 K2=IWK(ID+J)+KB
      K3=K2
      JJ=IWK(IC+J-1)
      JK=JJ
      K0=KB+JJ
      ISP=IWK(IC+J)-JJ
  235 K=K0+JJ
  240 ZA4=A(K0+1)
      A(K0+1)=A(K2+1)
      A(K2+1)=ZA4
      K0=K0+1
      K2=K2+1
      IF(K0.LT.K) GO TO 240
      K0=K0+ISP
      K2=K2+ISP
      IF(K0.LT.K3) GO TO 235
      IF(K0.GE.K3+ISP) GO TO 245
      K0=K0-IWK(ID+J)+JJ
      GO TO 235
  245 K3=IWK(ID+J)+K3
      IF(K3-KB.GE.IWK(ID+J-1)) GO TO 250
      K2=K3+JK
      JK=JK+JJ
      K0=K3-IWK(ID+J)+JK
      GO TO 235
  250 IF(J.GE.KT) GO TO 260
      K=IWK(J+1)+I
      J=J+1
  255 I=I+1
      IWK(ILL+I)=J
      IF(I.LT.K) GO TO 255
      GO TO 230
  260 KB=K3
      IF(I.LE.0) GO TO 265
      J=IWK(ILL+I)
      I=I-1
      GO TO 230
  265 IF(KB.GE.N) GO TO 270
      J=1
      GO TO 230
  270 JK=IWK(IC+KT)
      ISP=IWK(ID+KT)
      M=M-KT
      KB=ISP/JK-2
      IF(KT.GE.M-1) GO TO 9005
      ITA=ILL+KB+1
      ITB=ITA+JK
      IDM1=ID-1
      IKT=KT+1
      IM=M+1
      DO 275 J=IKT,IM
      IWK(IDM1+J)=IWK(IDM1+J)/JK
  275 CONTINUE
      JJ=0
      DO 290 J=1,KB
      K=KT
  280 JJ=IWK(ID+K+1)+JJ
      IF(JJ.LT.IWK(ID+K)) GO TO 285
      JJ=JJ-IWK(ID+K)
      K=K+1
      GO TO 280
  285 IWK(ILL+J)=JJ
      IF(JJ.EQ.J) IWK(ILL+J)=-J
  290 CONTINUE
C    DETERMINE THE PERMUTATION CYCLES
C    OF LENGTH GREATER THAN OR EQUAL TO TWO.
      DO 300 J=1,KB
      IF(IWK(ILL+J).LE.0) GO TO 300
      K2=J
  295 K2=IABS(IWK(ILL+K2))
      IF(K2.EQ.J) GO TO 300
      IWK(ILL+K2)=-IWK(ILL+K2)
      GO TO 295
  300 CONTINUE
C    REORDER A FOLLOWING THE PERMUATION CYCLES
      I=0
      J=0
      KB=0
      KN=N
      ITI=1
      ITT=1
  305 J=J+1
      IF(IWK(ILL+J).LT.0) GO TO 305
      K=IWK(ILL+J)
      K0=JK*K+KB
  310 ZA4=A(K0+I+1)
      WK(ITA+I)=A4
      WK(ITB+I)=B4
      I=I+1
      IF(I.LT.JK) GO TO 310
      I=0
  315 K=-IWK(ILL+K)
      JJ=K0
      K0=JK*K+KB
  320 A(JJ+I+1)=A(K0+I+1)
      I=I+1
      IF(I.LT.JK) GO TO 320
      I=0
      IF(K.NE.J) GO TO 315
  325 A(K0+I+1)=CMPLX(WK(ITA+I),WK(ITB+I))
      I=I+1
      IF(I.LT.JK) GO TO 325
      I=0
      IF(J.LT.K2) GO TO 305
      J=0
      KB=KB+ISP
      IF(KB.LT.KN) GO TO 305
 9005 RETURN
      END

*=========================================================================*

      SUBROUTINE ZERO1B(N,BUF)
      INTEGER  N
      REAL     BUF(N)

      DO I=1,N
         BUF(I) = 0.0
      ENDDO
      RETURN
      END

*========================================================

      SUBROUTINE ZERO2B(N,M,BUF)

      INTEGER  N,M
      REAL     BUF(N,M)

      DO I=1,N
         DO J=1,M
         BUF(I, J) = 0.0
         ENDDO
      ENDDO
      RETURN
      END

*===================================================*
*            THE END OF THE FILE                    *
*===================================================*
