module CONTROL_SUBROUTINE
use sep3d_struct_mod
use sep
implicit none
                                                                                                                                                  
contains
 
SUBROUTINE POSTSTACK_2D_DPMIG(velnz, velnx, datant, datanx, veldz, veldx,&
     veloz, velox, datadt, datadx, dataot, dataox, NX, Nz_step, &
     f1, f2, f3, f4, DIP_max, Threshold)

real :: datadt,dataot
REAL, allocatable :: BUFF(:)
INTEGER :: Nw1, Nw2, Nw3, Nw4, Nw
INTEGER :: velnz, velnx, datant, datanx, NX, Nz_step
REAL    :: veldz, veldx, Veloz, velox, datadx, dataox
REAL    :: f1, f2, f3, f4, DIP_max, Threshold
INTEGER :: L1, L2, L3, L4, L5, L6, L7, L8, L9
INTEGER :: L10, L11, L12, Lmemory

real :: Dw,W1,W2,W3,W4

integer,external :: sreed, srite
                                             
real :: PAI2

PAI2=2*3.14159265359
 
!write(*,*)'velnz, velnx, datant, datanx, veldz, veldx='
!write(*,*) velnz, velnx, datant, datanx, veldz, veldx
!write(*,*) 'veloz, velox, datadt, datadx, dataot, dataox, NX, Nz_step='
!write(*,*) veloz, velox, datadt, datadx, dataot, dataox, NX, Nz_step
!write(*,*) 'f1, f2, f3, f4, DIP_max, Threshold='
!write(*,*) f1, f2, f3, f4, DIP_max, Threshold

Dw=PAI2/(DATANT*DATADT)

W1=PAI2*F1
Nw1=W1/Dw+0.5
W2=PAI2*F2
Nw2=W2/Dw+0.5
W3=PAI2*F3
Nw3=W3/Dw+0.5
W4=PAI2*F4
Nw4=W4/Dw+0.5
Nw=Nw4-Nw1+1

write(*,*)  'DATANT*DATADT='
write(*,*)  DATANT,DATADT 
write(*,*) 'Nw1, nw2, nw3, nw4, nw, Dw, w1,='
write(*,*)  Nw1, nw2, nw3, nw4, nw, Dw, w1
                                                                              
L1 = 1 
L2 = L1+NZ_step
L3 = L2+DATANT
L4 = L3+DATANT*2
L5 = L4+3*NX
L6 = L5+NX
L7 = L6+NX*2
L8 = L7+NX*NZ_step
L9 = L8+NX*NZ_step
L10 = L9+DATANT*NX
L11 = L10+NX*NW*2
L12 = L11+NX*NW*2

Lmemory=L12+NX*NW*2

!write(*,*)'*********'
!write(*,*) 'Lmemory, NX, DATANT, NZ_step, Nw'
!write(*,*) Lmemory, NX, DATANT, NZ_step, Nw

allocate(BUFF(Lmemory))
!pause 33

CALL INPUT_DATA(BUFF(L1), BUFF(L2), BUFF(L7), BUFF(L9), velnz, velnx, datant, & 
datanx, veldz, veldx, &
     veloz, velox, datadt, datadx, dataot, dataox, NX, NZ_step)
!pause 44
CALL SSF_EXTRAP_AND_IMAG(BUFF(L2), BUFF(L3), BUFF(L4),  &
     BUFF(L5), BUFF(L6), BUFF(L7), BUFF(L8), &      
     BUFF(L9), BUFF(L10), BUFF(L11), BUFF(L12), &                                   
     NX, DATANT, VELDX, DATADT, NZ_step, VELDZ, Nw1, Nw2, Nw3,& 
     Nw4, Nw, Dw, DIP_max, Threshold)
!pause 55 
CALL OUTPUT_DATA(BUFF(L7), BUFF(L8), VELNX, NZ_step)

deallocate(BUFF)
 
WRITE(*,*) '*=======================================*'
WRITE(*,*) '*     FOURIER MIGRATION END !!          *'
WRITE(*,*) '*=======================================*'

END SUBROUTINE POSTSTACK_2D_DPMIG

SUBROUTINE INPUT_DATA(TRACE, VEL, VELBIN, DATABIN, velnz, velnx, datant, datanx, veldz, veldx, &
     veloz, velox, datadt, datadx, dataot, dataox, NX, NZ_step)

INTEGER :: VELNZ, VELNX, DATANT, DATANX, NX, NZ_step
REAL    :: VELDZ, VELDX, DATADT, DATADX
REAL    :: VELOZ, VELOX, DATAOT, DATAOX

REAL    :: TRACE(DATANT), VEL(NZ_step)
REAL    :: VELBIN(NZ_step, NX), DATABIN(DATANT, NX)
real,allocatable :: veltmp(:,:)
REAL    :: xleft_max, xright_min
INTEGER :: Idd, Ivv,iv,iz,it,id
INTEGER :: nstart_vel, nend_vel
INTEGER :: nstart_data, nend_data
integer,external:: sreed,srite

xleft_max=max(dataox, velox)
xright_min=min(veldx*velnx, datadx*datanx)

nstart_vel=xleft_max/veldx+1
nend_vel=xright_min/veldx

!write(*,*) 'ppppppppp'  
Ivv=1

!write(*,*)"Nx=",Nx,"Nz_step=",Nz_step

!do iv=nstart_vel, nend_vel

if (sreed("Velocity",velbin, Nx*Nz_step*4)/=Nx*Nz_step*4) &
        call seperr("read velocity wrong")

!   DO Iz=1, NZ_step
!    VELBIN(Iz, Ivv)=VEL(Iz)
!   ENDDO
!Ivv=Ivv+1
!end do

!write(*,*) 'jksjkksdkl'

nstart_data=xleft_max/datadx+1
nend_data=xright_min/datadx

Idd=1
DO Id=nstart_data, nend_data
if (sreed("Inputdata",trace,datant*4)/=datant*4) &
        call seperr("read data wrong")
   DO IT=1,  DATANT
    DATABIN(IT, Id)=TRACE(IT)
   END DO
Idd=Idd+1
ENDDO
!write(*,*) 'i99999999'
END SUBROUTINE INPUT_DATA

SUBROUTINE OUTPUT_DATA(REFVEO, IMAGE, NX, NZ_step)

INTEGER :: NX, NZ_step, IZ, IX

REAL    :: IMAGE(NZ_step, NX), REFVEO(NZ_step, NX)
integer,external :: srite
!write(*,*)"aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
!write(*,*)"Nx=",Nx,"Nz=",Nz_step

if (srite("Image", IMAGE, NZ_step*NX*4)/=NZ_step*NX*4) &
        call seperr("write image wrong")

if (srite("Refveo", REFVEO, NZ_step*NX*4)/=NZ_step*NX*4) &
        call seperr("write refveo wrong")
!write(*,*)"bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb"

END SUBROUTINE OUTPUT_DATA

END MODULE CONTROL_SUBROUTINE








